/*
MySQL-kannasta haettu data esitetään web-sivulla JSON-muodossa.
Jotta data saadaan webbiin, pitää luoda http-serveri.
Aja komennolla: node nodemysqlweb ja mene selaimella osoitteseen localhost:3080
*/
const http = require('http');
const conn = require('./mysqlconn');

// Voidaan tarvittaessa tutkia toimiiko yhteys MySQL-kantaan
conn.connect((err) => {
  if (err) {
    return console.error('MySQL yhteysvirhe: ' + err.message);
  }
  console.log('Yhteys MySQL-kantaan toimii!');
});

/* Nodella ilman mitään apukirjastoa luotu http-serveri, jonka
   argumenttina olevassa callbackissa tehdään MySQL-kysely.
   Kyselyn tulos saadaan query-metodin callbackissa.
*/

http
  .createServer((req, res) => {
    // MySQL-kysely
    conn.query('SELECT * FROM opiskelijat;', (err, rows, fields) => {
      if (err) {
        return console.error('MySQL kyselyvirhe: ' + err.message);
      }
      // Kyselyn tulos saadaan query-metodin callbackissa
      // rows-muuttujassa JSON-muotoisena, koska webbiin voi lähettää vain JSONia.
      res.end(JSON.stringify(rows));
    });
  })
  .listen(3080);
console.log('Serveri toimii portissa 3080');
